package es.us.eii.pfc.jcrbib.data;

/**
 * Factoria abstracta que forma parte de la implementacin del patrn DAO
 * 
 * 
 * 
 */
public abstract class DAOFactory {

	/**
	 * En este caso, slo tenemos un tipo de implementacin
	 */
	public static final int JCR = 1;

	public static DAOFactory getDAOFactory(int whichFactory) {

		switch (whichFactory) {
		case JCR:
			return new JcrDAOFactory();
		default:
			return null;
		}
	}

	/**
	 * Mtodo abstracto que devuelve el objeto IUserDAO
	 * 
	 * @return Un objeto de tipo IUserDAO (que depende de la implementacin)
	 */
	public abstract IUserDAO getUserDAO();

	/**
	 * Mtodo abstracto que devuelve el objeto ITagDAO
	 * 
	 * @return Un objeto de tipo ITagDAO (que depende de la implementacin)
	 */
	public abstract ITagDAO getTagDAO();

	/**
	 * Mtodo abstracto que devuelve el objeto IMyArticleDAO
	 * 
	 * @return Un objeto de tipo IMyArticleDAO (que depende de la implementacin)
	 */
	public abstract IMyArticleDAO getMyArticleDAO();
}
