package es.us.eii.pfc.jcrbib.presentation;

import static es.us.eii.pfc.jcrbib.utils.ConstantsUtils.LOGGERNAME;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.log4j.Logger;

import es.us.eii.pfc.jcrbib.utils.RepositoryUtils;

/**
 * Filtro que se encarga de parar el repositorio 
 * cuando se para la aplicacin
 * 
 * @author Enrique Jess Cardona
 *
 */
public class RepositoryControlFilter implements Filter {

	protected Logger log = Logger.getLogger(LOGGERNAME);

	public void init(FilterConfig arg0) throws ServletException {
		log.info("************Arrancando RepositoryControlFilter************");
	}

	public void doFilter(ServletRequest req, ServletResponse resp,
			FilterChain chain) throws IOException, ServletException {
		// El filtro slo se encarga de controlar que el repositorio se para
		// cuando es necesario
		chain.doFilter(req, resp);
	}

	public void destroy() {
		RepositoryUtils.shutdownRepository();
		log.info("************Parando RepositoryControlFilter************");
	}

}
