package es.us.eii.pfc.jcrbib.utils;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import sun.misc.BASE64Encoder;

/**
 * 
 * Clase para codificar las contraseas de usuario
 * 
 * 
 * 
 */
public final class SHA1BASE64 {
	/**
	 * 
	 * Mtodo que encripta un texto pasado
	 * @param texto Texto a encriptar
	 * @return El texto encriptado
	 */
	public static String encriptar(String texto) throws IllegalStateException {
		MessageDigest msgDigst = null;

		try {
			msgDigst = MessageDigest.getInstance("SHA"); // Generador SHA-1

		} catch (NoSuchAlgorithmException e) {
			throw new IllegalStateException(e.getMessage());
		}

		try {
			msgDigst.update(texto.getBytes("UTF-8")); // Generacion del
														// resumen del mensaje
		} catch (UnsupportedEncodingException e) {
			throw new IllegalStateException(e.getMessage());
		}

		byte raw[] = msgDigst.digest(); // Obtencin del resumen del mensaje
		String out = (new BASE64Encoder()).encode(raw); // Traducimos a BASE64
		return out;
	}
}
