<%--@ page errorPage="/portal/error/error.jsp?from=initUsers.jsp"--%>

<%@ page import="es.us.eii.pfc.jcrbib.domain.*"%>
<%@ page import="es.us.eii.pfc.jcrbib.data.*"%>
<%@ page import="es.us.eii.pfc.jcrbib.utils.*"%>
<%@ page import="java.util.*"%>

<%@ taglib prefix="c" uri="/WEB-INF/tld/c.tld"%>

<% 
	DAOFactory factory = DAOFactory.getDAOFactory(DAOFactory.JCR);
	IUserDAO userDAO = factory.getUserDAO();
	ITagDAO tagDAO = factory.getTagDAO();
	IMyArticleDAO myArticleDAO = factory.getMyArticleDAO();
	
	SortedSet<MyArticle> renderArticles = new TreeSet<MyArticle>();
	SortedSet<MyArticle> userArticles = new TreeSet<MyArticle>();
	SortedSet<String> tags = new TreeSet<String>();
	String userName = request.getParameter("user");
	String tagName = request.getParameter("tag");
	
	boolean error = false;
	String errorCause = "";
	
	if (userName != null) {
		if (userDAO.existsUser(userName)) {
			userArticles = myArticleDAO.getMyArticles(userName);
		} else {
			error= true;
			errorCause = "Usuario especificado inexistente";
		}
	} else {
		SortedSet<User> usuarios = userDAO.getUsers();
		for(User user : usuarios){
			userArticles.addAll(myArticleDAO.getMyArticles(user.getName()));
		}
	}
	
	if(!error){
		if (tagName!= null && tagDAO.existsTag(tagName)){
			for(MyArticle a : userArticles){
				if(a.getTags().contains(tagName)){
					renderArticles.add(a);
				}
			}
		} else {
			renderArticles = userArticles;
		}
		
		for(MyArticle a:renderArticles){
			tags.addAll(a.getTags());
		}
		
		pageContext.setAttribute("tags", tags);
		pageContext.setAttribute("renderArticles", renderArticles);
	}
%>
<c:import url="/WEB-INF/jspf/header.jsp" context="/jcrbib" />

<% if (!error) { %>
<p class="breadcrumb"><a href="/jcrbib/portal">Inicio </a> &raquo; <a
	href="/jcrbib/portal/bib/">Biblioteca</a> <c:if
	test="${!empty param.user}">
		&raquo; <a
		href="/jcrbib/portal/bib/?user=<c:out value="${param.user}" />"><c:out
		value="${param.user}" /></a>
	<c:if test="${!empty param.tag}">
			&raquo; <a
			href="/jcrbib/portal/bib/?user=<c:out value="${param.user}" />&amp;tag=<c:out value="${param.tag}" />"><c:out
			value="${param.tag}" /></a>
	</c:if>
</c:if></p>
<h2>Biblioteca <c:if test="${!empty param.user}">
	&raquo; usuario <c:out value="${param.user}" />
	<c:if test="${!empty param.tag}">
		&raquo; tag <c:out value="${param.tag}" />
	</c:if>
</c:if></h2>

<c:if test="${!empty tags}">
	<div id="taglist"><% User userLink = null;
	if(userName!=null){
		userLink = userDAO.getUser(userName);
	}%>
	<ul>
		<c:forEach items="${tags}" var="tag">
			<li><%=ShowUtils.tagSizedLink(
					tagDAO.getTag((String)pageContext.getAttribute("tag")),
					userLink) %></li>
		</c:forEach>
	</ul>
	</div>
</c:if>

<ul class="articlelist">
	<c:forEach items="${renderArticles}" var="article">
		<% MyArticle art = (MyArticle)pageContext.getAttribute("article"); %>
		<li><%=ShowUtils.verResumenArticulo(art, userName)%>
		<%--=ShowUtils.verUsuariosArticulo(art, userName)--%></li>
	</c:forEach>
</ul>
<% } else { %>
<p>Se ha producido un error.</p>
<p><%=errorCause %></p>
<% } %>

<p><a class="backButton"
	href="/jcrbib/portal/bib/<%=(userName != null && tagName!=null?"?user="+userName:"") %>">Volver</a></p>

<c:import url="/WEB-INF/jspf/footer.jsp" context="/jcrbib" />
